#include "Child_Process_Library_Constants.au3"

If $CmdLine[0] = 0 Or Not ($CmdLine[1] == "NewChProcess") Then
ParentWinMain()
Else
StartWinMain()
EndIf

Func ParentWinMain()

$ProcNumA = NewChProcess()
$Return = CallChProcess($ProcNumA,"cMsgBoxA",0,10,20,PtrToCallPtr("String"))
MsgBox(0,"Parent Process",$Return)

$ProcNumB = NewChProcess()
$Struct = DllStructCreate("int NumA;Int NumB;WCHAR Text[10]")
DllStructSetData($Struct,1,100)
DllStructSetData($Struct,2,200)
DllStructSetData($Struct,3,"0123456789")
$StructPtr = DllStructGetPtr($Struct)
$Return = CallChProcess($ProcNumB,"cMsgBoxB",0,10,20,PtrToCallPtr($StructPtr,0,"int NumA;Int NumB;WCHAR Text[10]"))
MsgBox(0,"Parent Process",$Return)

$ProcNumC = NewChProcess()
$Struct = DllStructCreate("int NumA;Int NumB;WCHAR Text[10]")
DllStructSetData($Struct,1,100)
DllStructSetData($Struct,2,200)
DllStructSetData($Struct,3,"0123456789")
$StructPtr = DllStructGetPtr($Struct)
$StructSize = DllStructGetSize($Struct)
$Return = CallChProcess($ProcNumC,"cMsgBoxC",0,10,20,PtrToCallPtr($StructPtr,$StructSize))
MsgBox(0,"Parent Process",CallPtrToPtr($Return,Prohandle_From_ProNum($ProcNumC)))

EndFunc

Func ChildWinMain()

Return True ; False Exit /// True Continue

EndFunc

Func StartWinMain()

$IsChildProcess = True
$yCallPtr = Ptr($CmdLine[4])
$ParentProcessID = Int($CmdLine[3])
$yProcessNumber  = Int($CmdLine[2])
$ParentProhandle = GetPro_handle(0,$ParentProcessID)

cRead_Ptr($ParentProhandle,$yCallPtr,$CallPtr,$CallSize)

DllStructSetData($CallStruct,"cFinish",1,$yProcessNumber)
DllStructSetData($CallStruct,"CallPtr",$CallPtr,$yProcessNumber)
DllStructSetData($CallStruct,"ChProcessID",$ProcessID,$yProcessNumber)

cWrite_Ptr($ParentProhandle,$yCallPtr,$CallPtr,$CallSize)

While IsParentProcessWork() And ChildWinMain()
if DllStructGetData($CallStruct,"TestCall",$yProcessNumber) Then CallFunc()
WEnd
Exit

EndFunc

Func IsParentProcessWork($pTime = 5000)
if (TimerDiff($pbeginA) < $pTime) Then Return True
if Not ProcessExists($ParentProcessID) Then Return False
$pbeginA = TimerInit()
Return True
EndFunc

Func cMsgBoxA($vA,$vB,$vC)
$String = CallPtrToPtr($vC,$ParentProhandle) ;$vC Is A String Ptr
MsgBox(0,"Child Process cMsgBoxA",$vA & "  " &  $vB & "  " & $String )
Return ReturnToReturnCall($vA * $vB)
EndFunc

Func cMsgBoxB($vA,$vB,$vC)
$Struct = CallPtrToPtr($vC,$ParentProhandle) ;$vC Is A Struct Ptr
MsgBox(0,"Child Process cMsgBoxB",$vA & "  " &  $vB )
$Text =  "NumA Is " & DllStructGetData($Struct,"NumA") & @CRLF
$Text &= "NumB Is " & DllStructGetData($Struct,"NumB") & @CRLF
$Text &= "Text Is " & DllStructGetData($Struct,"Text") & @CRLF
MsgBox(0,"Child Process cMsgBoxB",$Text)
Return ReturnToReturnCall($vA + $vB)
EndFunc

Func cMsgBoxC($vA,$vB,$vC)
$Struct = CallPtrToPtr($vC,$ParentProhandle) ;$vC Is A Bytes Struct Ptr
MsgBox(0,"Child Process cMsgBoxC",DllStructGetData($Struct,1) )
$iStruct = DllStructCreate("int NumA;Int NumB;WCHAR Text[10]",DllStructGetPtr($Struct))
$Text =  "NumA Is " & DllStructGetData($iStruct,"NumA") & @CRLF
$Text &= "NumB Is " & DllStructGetData($iStruct,"NumB") & @CRLF
$Text &= "Text Is " & DllStructGetData($iStruct,"Text") & @CRLF
MsgBox(0,"Child Process cMsgBoxC",$Text)
Return ReturnToReturnCall(PtrToCallPtr("String"))
EndFunc

Func NewChProcess($WaitChildProcess = True , $Timeout = 5000) ; Calling From Parent Process Only

if $IsChildProcess Then Return SetError(1,0,0) ;error 1 if Calling From Child Process

if $cMax = $wProcessCount Then Return SetError(2,0,0) ;error 2 Upto Max Of Child dProcess

$wProcessCount += 1
DllStructSetData($CallStruct,"cFinish",0,$wProcessCount)

$Command = "NewChProcess " & $wProcessCount & " " & $ProcessID & " " & $CallPtr

if (@Compiled) Then
$ChProcessID = Run(FileGetShortName(@AutoItExe) & " " & $Command)
Else
$ChProcessID = Run(FileGetShortName(@AutoItExe) & " " & FileGetShortName(@ScriptFullPath) & " " & $Command)
EndIf

if $WaitChildProcess Then
$begin = TimerInit()
While Not DllStructGetData($CallStruct,"cFinish",$wProcessCount) And _
ProcessExists($ChProcessID) And TimerDiff($begin) <= $Timeout
Sleep(100)
WEnd
EndIf

$Prohandle = GetPro_handle(0,$ChProcessID)
if @error Then Return SetError(3,0,0) ; error 3 error In Get Child Process handle

DllStructSetData($CallStruct,"ChProcesshandle",$Prohandle,$wProcessCount)
; Return New Child Process Number
Return $wProcessCount

EndFunc

Func CallChProcess($ProcessNum,$FNam,$RtIly,$Pam1 = 0,$Pam2 = 0,$Pam3 = 0 _
 , $Pam4 = 0 , $Pam5 = 0 ,$Pam6 = 0,$Pam7 = 0,$Pam8 = 0,$Pam9 = 0,$Pam10 = 0)

Local $NumParams = @NumParams - 3
DllStructSetData($CallStruct,"ParamCount",$NumParams)

Select
Case $NumParams = 1
DllStructSetData($CallStruct,2,$Pam1)
Case $NumParams = 2
DllStructSetData($CallStruct,2,$Pam1)
DllStructSetData($CallStruct,3,$Pam2)
Case $NumParams = 3
DllStructSetData($CallStruct,2,$Pam1)
DllStructSetData($CallStruct,3,$Pam2)
DllStructSetData($CallStruct,4,$Pam3)
Case $NumParams = 4
DllStructSetData($CallStruct,2,$Pam1)
DllStructSetData($CallStruct,3,$Pam2)
DllStructSetData($CallStruct,4,$Pam3)
DllStructSetData($CallStruct,5,$Pam4)
Case $NumParams = 5
DllStructSetData($CallStruct,2,$Pam1)
DllStructSetData($CallStruct,3,$Pam2)
DllStructSetData($CallStruct,4,$Pam3)
DllStructSetData($CallStruct,5,$Pam4)
DllStructSetData($CallStruct,6,$Pam5)
Case $NumParams = 6
DllStructSetData($CallStruct,2,$Pam1)
DllStructSetData($CallStruct,3,$Pam2)
DllStructSetData($CallStruct,4,$Pam3)
DllStructSetData($CallStruct,5,$Pam4)
DllStructSetData($CallStruct,6,$Pam5)
DllStructSetData($CallStruct,7,$Pam6)
Case $NumParams = 7
DllStructSetData($CallStruct,2,$Pam1)
DllStructSetData($CallStruct,3,$Pam2)
DllStructSetData($CallStruct,4,$Pam3)
DllStructSetData($CallStruct,5,$Pam4)
DllStructSetData($CallStruct,6,$Pam5)
DllStructSetData($CallStruct,7,$Pam6)
DllStructSetData($CallStruct,8,$Pam7)
Case $NumParams = 8
DllStructSetData($CallStruct,2,$Pam1)
DllStructSetData($CallStruct,3,$Pam2)
DllStructSetData($CallStruct,4,$Pam3)
DllStructSetData($CallStruct,5,$Pam4)
DllStructSetData($CallStruct,6,$Pam5)
DllStructSetData($CallStruct,7,$Pam6)
DllStructSetData($CallStruct,8,$Pam7)
DllStructSetData($CallStruct,9,$Pam8)
Case $NumParams = 9
DllStructSetData($CallStruct,2, $Pam1)
DllStructSetData($CallStruct,3, $Pam2)
DllStructSetData($CallStruct,4, $Pam3)
DllStructSetData($CallStruct,5, $Pam4)
DllStructSetData($CallStruct,6, $Pam5)
DllStructSetData($CallStruct,7, $Pam6)
DllStructSetData($CallStruct,8, $Pam7)
DllStructSetData($CallStruct,9, $Pam8)
DllStructSetData($CallStruct,10,$Pam9)
Case $NumParams = 10
DllStructSetData($CallStruct,2, $Pam1)
DllStructSetData($CallStruct,3, $Pam2)
DllStructSetData($CallStruct,4, $Pam3)
DllStructSetData($CallStruct,5, $Pam4)
DllStructSetData($CallStruct,6, $Pam5)
DllStructSetData($CallStruct,7, $Pam6)
DllStructSetData($CallStruct,8, $Pam7)
DllStructSetData($CallStruct,9, $Pam8)
DllStructSetData($CallStruct,10,$Pam9)
DllStructSetData($CallStruct,11,$Pam10)
EndSelect

$yCallPtr = DllStructGetData($CallStruct,"CallPtr",$ProcessNum)
$ChProceID = DllStructGetData($CallStruct,"ChProcessID",$ProcessNum)
$Prohandle = DllStructGetData($CallStruct,"ChProcesshandle",$ProcessNum)

DllStructSetData($CallStruct,"FucName",$FNam) ; Func Name
DllStructSetData($CallStruct ,"RtIly",$RtIly) ; Return immediately
DllStructSetData($CallStruct,"cFinish",0,$ProcessNum)
DllStructSetData($CallStruct,"TestCall",1,$ProcessNum)

cWrite_Ptr($Prohandle,$yCallPtr,$CallPtr,$CallSize)

Local $BoolA = False , $BoolB = True

While ((Not $BoolA) And $BoolB)
$BoolA = DllStructGetData($CallStruct,"cFinish",$ProcessNum)
$BoolB = ProcessExists($ChProceID)
Sleep(100)
WEnd

if $BoolA Then
if $RtIly Then Return SetError(0,0,0)
$ReturnPtr = DllStructGetData($CallStruct,"ReturnPtr")
Return ReturnCallToReturn($ReturnPtr,$Prohandle)
EndIf

Return SetError(1,0,0)

EndFunc

Func CallFunc()

$FuncName  = DllStructGetData($CallStruct,"FucName")
$NumParams = DllStructGetData($CallStruct,"ParamCount")
$RtIly = DllStructGetData($CallStruct,"RtIly") ;Return immediately

Local $ArgsArray[$NumParams + 1]
$ArgsArray[0] = "CallArgArray"

Select
Case $NumParams = 1
$ArgsArray[1] = DllStructGetData($CallStruct,2)
Case $NumParams = 2
$ArgsArray[1] = DllStructGetData($CallStruct,2)
$ArgsArray[2] = DllStructGetData($CallStruct,3)
Case $NumParams = 3
$ArgsArray[1] = DllStructGetData($CallStruct,2)
$ArgsArray[2] = DllStructGetData($CallStruct,3)
$ArgsArray[3] = DllStructGetData($CallStruct,4)
Case $NumParams = 4
$ArgsArray[1] = DllStructGetData($CallStruct,2)
$ArgsArray[2] = DllStructGetData($CallStruct,3)
$ArgsArray[3] = DllStructGetData($CallStruct,4)
$ArgsArray[4] = DllStructGetData($CallStruct,5)
Case $NumParams = 5
$ArgsArray[1] = DllStructGetData($CallStruct,2)
$ArgsArray[2] = DllStructGetData($CallStruct,3)
$ArgsArray[3] = DllStructGetData($CallStruct,4)
$ArgsArray[4] = DllStructGetData($CallStruct,5)
$ArgsArray[5] = DllStructGetData($CallStruct,6)
Case $NumParams = 6
$ArgsArray[1] = DllStructGetData($CallStruct,2)
$ArgsArray[2] = DllStructGetData($CallStruct,3)
$ArgsArray[3] = DllStructGetData($CallStruct,4)
$ArgsArray[4] = DllStructGetData($CallStruct,5)
$ArgsArray[5] = DllStructGetData($CallStruct,6)
$ArgsArray[6] = DllStructGetData($CallStruct,7)
Case $NumParams = 7
$ArgsArray[1] = DllStructGetData($CallStruct,2)
$ArgsArray[2] = DllStructGetData($CallStruct,3)
$ArgsArray[3] = DllStructGetData($CallStruct,4)
$ArgsArray[4] = DllStructGetData($CallStruct,5)
$ArgsArray[5] = DllStructGetData($CallStruct,6)
$ArgsArray[6] = DllStructGetData($CallStruct,7)
$ArgsArray[7] = DllStructGetData($CallStruct,8)
Case $NumParams = 8
$ArgsArray[1] = DllStructGetData($CallStruct,2)
$ArgsArray[2] = DllStructGetData($CallStruct,3)
$ArgsArray[3] = DllStructGetData($CallStruct,4)
$ArgsArray[4] = DllStructGetData($CallStruct,5)
$ArgsArray[5] = DllStructGetData($CallStruct,6)
$ArgsArray[6] = DllStructGetData($CallStruct,7)
$ArgsArray[7] = DllStructGetData($CallStruct,8)
$ArgsArray[8] = DllStructGetData($CallStruct,9)
Case $NumParams = 9
$ArgsArray[1] = DllStructGetData($CallStruct,2)
$ArgsArray[2] = DllStructGetData($CallStruct,3)
$ArgsArray[3] = DllStructGetData($CallStruct,4)
$ArgsArray[4] = DllStructGetData($CallStruct,5)
$ArgsArray[5] = DllStructGetData($CallStruct,6)
$ArgsArray[6] = DllStructGetData($CallStruct,7)
$ArgsArray[7] = DllStructGetData($CallStruct,8)
$ArgsArray[8] = DllStructGetData($CallStruct,9)
$ArgsArray[9] =DllStructGetData($CallStruct,10)
Case $NumParams = 10
$ArgsArray[1] = DllStructGetData($CallStruct,2)
$ArgsArray[2] = DllStructGetData($CallStruct,3)
$ArgsArray[3] = DllStructGetData($CallStruct,4)
$ArgsArray[4] = DllStructGetData($CallStruct,5)
$ArgsArray[5] = DllStructGetData($CallStruct,6)
$ArgsArray[6] = DllStructGetData($CallStruct,7)
$ArgsArray[7] = DllStructGetData($CallStruct,8)
$ArgsArray[8] = DllStructGetData($CallStruct,9)
$ArgsArray[9] =DllStructGetData($CallStruct,10)
$ArgsArray[10]=DllStructGetData($CallStruct,11)
EndSelect

if $RtIly Then

DllStructSetData($CallStruct ,"cFinish",1,$yProcessNumber)
DllStructSetData($CallStruct,"TestCall",0,$yProcessNumber)
cWrite_Ptr($ParentProhandle,$yCallPtr,$CallPtr,$CallSize)

EndIf

$ReturnPtr = Call($FuncName,$ArgsArray)

if Not $RtIly Then

DllStructSetData($CallStruct ,"cFinish",1,$yProcessNumber)
DllStructSetData($CallStruct,"TestCall",0,$yProcessNumber)
DllStructSetData($CallStruct,"ReturnPtr",$ReturnPtr)
cWrite_Ptr($ParentProhandle,$yCallPtr,$CallPtr,$CallSize)

EndIf

EndFunc

Func CallPtrToPtr($PtrOrStr,$Prohandle)

$Struct = DllStructCreate("Byte Type;Int LenAndSize")
$Pointer = DllStructGetPtr($Struct)
$Size  =  DllStructGetSize($Struct)
cRead_Ptr($Prohandle,$PtrOrStr,$Pointer,$Size)
$LenAndSize = DllStructGetData($Struct,2)

Switch DllStructGetData($Struct,1)
Case 1
$yTagStruct = "Byte Type;Int Len;WCHAR[" & $LenAndSize & "]"
$Struct = DllStructCreate($yTagStruct)
$Pointer = DllStructGetPtr($Struct)
$Size = DllStructGetSize($Struct)
cRead_Ptr($Prohandle,$PtrOrStr,$Pointer,$Size)
Return SetError(0,1,DllStructGetData($Struct,3))

Case 2

$yTagStruct = "Byte Type;Int Len;Byte[" & $LenAndSize & "]"
$Struct = DllStructCreate($yTagStruct)
$Pointer = DllStructGetPtr($Struct)
$Size = DllStructGetSize($Struct)
cRead_Ptr($Prohandle,$PtrOrStr,$Pointer,$Size)
$yStruct =  DllStructCreate("byte[" & $LenAndSize & "]")

$BPtr = DllStructGetPtr($Struct,3)
$YPtr =  DllStructGetPtr($yStruct)
_MemMoveMemory($BPtr,$YPtr,$LenAndSize)

Return SetError(0,2,$yStruct)

Case 3

$yTagStruct = "Byte Type;Int Size;Byte[" & $LenAndSize & "];WCHAR TagSt[1000]"
$Struct = DllStructCreate($yTagStruct)
$Pointer = DllStructGetPtr($Struct)
$Size = DllStructGetSize($Struct)
cRead_Ptr($Prohandle,$PtrOrStr,$Pointer,$Size)

$TagSt = DllStructGetData($Struct,4)
$yStruct =  DllStructCreate($TagSt)

$BPtr = DllStructGetPtr($Struct,3)
$YPtr =  DllStructGetPtr($yStruct)
_MemMoveMemory($BPtr,$YPtr,$LenAndSize)
Return SetError(0,3,$yStruct)

EndSwitch

Return SetError(2,0,0)

EndFunc

Func PtrToCallPtr($PtrOrStr,$Size = 0,$yTagStruct = -1)

Local $Struct

Select
Case IsString($PtrOrStr)

$cLen = StringLen($PtrOrStr)
$Struct = DllStructCreate("Byte Type;Int Len;WCHAR[" & $cLen & "]")
DllStructSetData($Struct,1,1)
DllStructSetData($Struct,2,$cLen)
DllStructSetData($Struct,3,$PtrOrStr)

Case Else

Select
Case $yTagStruct == -1

$yTagStruct = "Byte Type;Int Size;Byte[" & $Size & "]"
$Struct = DllStructCreate($yTagStruct)
DllStructSetData($Struct,1,2)
DllStructSetData($Struct,2,$Size)
_MemMoveMemory($PtrOrStr,DllStructGetPtr($Struct,3),$Size)

Case Else

if StringLen($yTagStruct) > 1000 Then Return SetError(1,0,0)

if $Size = 0 Then $Size = DllStructGetSize(DllStructCreate($yTagStruct))
$cTagStruct = "Byte Type;Int Size;Byte[" & $Size & "];WCHAR TagSt[1000]"
$Struct = DllStructCreate($cTagStruct)
DllStructSetData($Struct,1,3)
DllStructSetData($Struct,2,$Size)
DllStructSetData($Struct,4,$yTagStruct)
_MemMoveMemory($PtrOrStr,DllStructGetPtr($Struct,3),$Size)

EndSelect

EndSelect

StructSetGlobal($Struct) ; Read Text In StructSetGlobal Func
Return SetError(0,0,DllStructGetPtr($Struct))

EndFunc

Func StructSetGlobal($Struct)
; StructSetGlobal
; Set Struct In Global if Struct From Child Process and Read it From Parent Process Or Struct From
;Parent Process and Read it From Child Process
;You can Set 20 Structs before deleting the first Struct /// $GlobalStNum = 20
Switch $GlobalStNum
Case $MaxGlobal
$GlobalStArray[$GlobalStNum - 1] = $Struct
$GlobalStNum = 1
Return $GlobalStNum
Case Else
$GlobalStArray[$GlobalStNum - 1] = $Struct
$GlobalStNum += 1
Return $GlobalStNum
EndSwitch
EndFunc

Func ReturnCallToReturn($ReturnPtr,$Prohandle)
$Struct = DllStructCreate("Double")
$Pointer = DllStructGetPtr($Struct)
$Size = DllStructGetSize($Struct)
cRead_Ptr($Prohandle,$ReturnPtr,$Pointer,$Size)
Return DllStructGetData($Struct,1)
EndFunc

Func ReturnToReturnCall($iData)
$ReturnSt = DllStructCreate("Double") ; On Global
DllStructSetData($ReturnSt,1,$iData)
Return DllStructGetPtr($ReturnSt)
EndFunc

Func Prohandle_From_ProNum($ProNumber = -1)
if $ProNumber = -1 Then Return $ParentProhandle
Return DllStructGetData($CallStruct,"ChProcesshandle",$ProNumber)
EndFunc

Func GetPro_handle($eProcessNumber = 0,$iProcessID = -1)
if $iProcessID = -1 Then $iProcessID = DllStructGetData($CallStruct,"ChProcessID",$eProcessNumber)
$ihProcess = _WinAPI_OpenProcess($iPROCESS_ALL_ACCESS,False,$iProcessID)
Return SetError(@error,0,$ihProcess)
EndFunc

Func cWrite_Ptr($ihProcess,$Address,$Pointer,$Size)
Local $iWritten
$Return = _WinAPI_WriteProcessMemory($ihProcess,$Address,$Pointer,$Size,$iWritten)
Return SetError($Return == False,0,$Return)
EndFunc

Func cRead_Ptr($ihProcess,$Address,$Pointer,$Size)
Local $iRead
$Return = _WinAPI_ReadProcessMemory($ihProcess,$Address,$Pointer,$Size,$iRead)
Return SetError($Return == False,0,$Return)
EndFunc

Func CloseProcesshandle($ihProcess)
Return _WinAPI_CloseHandle($ihProcess)
EndFunc
